package cn.com.ctop.kuaishou.modules.ai.controller;

import cn.com.ctop.kuaishou.modules.ai.entity.AiKuaishouCreativeLevelOperationRecord;
import cn.com.ctop.kuaishou.modules.ai.service.IAiKuaishouCreativeLevelOperationRecordService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

/**
* 自定义创意创建记录
* @author jeecg-boot
* @date   2021-04-12
* @version V1.0
*/
@Slf4j
@Api(tags="自定义创意创建记录")
@RestController
@RequestMapping("/ctop/aiKuaishouCreativeLevelOperationRecord")
public class AiKuaishouCreativeLevelOperationRecordController {
   @Autowired
   private IAiKuaishouCreativeLevelOperationRecordService aiKuaishouCreativeLevelOperationRecordService;

   /**
     * 分页列表查询
    * @param aiKuaishouCreativeLevelOperationRecord
    * @param pageNo
    * @param pageSize
    * @param req
    * @return
    */
   @GetMapping(value = "/list")
   public Result<IPage<AiKuaishouCreativeLevelOperationRecord>> queryPageList(AiKuaishouCreativeLevelOperationRecord aiKuaishouCreativeLevelOperationRecord,
                                                                              @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                                                              @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                                                              HttpServletRequest req) {
       Result<IPage<AiKuaishouCreativeLevelOperationRecord>> result = new Result<>();
       QueryWrapper<AiKuaishouCreativeLevelOperationRecord> queryWrapper = QueryGenerator.initQueryWrapper(aiKuaishouCreativeLevelOperationRecord, req.getParameterMap());
       Page<AiKuaishouCreativeLevelOperationRecord> page = new Page<AiKuaishouCreativeLevelOperationRecord>(pageNo, pageSize);
       IPage<AiKuaishouCreativeLevelOperationRecord> pageList = aiKuaishouCreativeLevelOperationRecordService.page(page, queryWrapper);
       result.setSuccess(true);
       result.setResult(pageList);
       return result;
   }

   /**
     *   添加
    * @param aiKuaishouCreativeLevelOperationRecord
    * @return
    */
   @PostMapping(value = "/add")
   public Result<AiKuaishouCreativeLevelOperationRecord> add(@RequestBody AiKuaishouCreativeLevelOperationRecord aiKuaishouCreativeLevelOperationRecord) {
       Result<AiKuaishouCreativeLevelOperationRecord> result = new Result<>();
       try {
           aiKuaishouCreativeLevelOperationRecordService.save(aiKuaishouCreativeLevelOperationRecord);
           result.success("添加成功！");
       } catch (Exception e) {
           log.error(e.getMessage(),e);
           result.error500("操作失败");
       }
       return result;
   }

   /**
     *  编辑
    * @param aiKuaishouCreativeLevelOperationRecord
    * @return
    */
   @PutMapping(value = "/edit")
   public Result<AiKuaishouCreativeLevelOperationRecord> edit(@RequestBody AiKuaishouCreativeLevelOperationRecord aiKuaishouCreativeLevelOperationRecord) {
       Result<AiKuaishouCreativeLevelOperationRecord> result = new Result<AiKuaishouCreativeLevelOperationRecord>();
       AiKuaishouCreativeLevelOperationRecord aiKuaishouCreativeLevelOperationRecordEntity = aiKuaishouCreativeLevelOperationRecordService.getById(aiKuaishouCreativeLevelOperationRecord.getCreativeUuid());
       if(aiKuaishouCreativeLevelOperationRecordEntity==null) {
           result.error500("未找到对应实体");
       }else {
           boolean ok = aiKuaishouCreativeLevelOperationRecordService.updateById(aiKuaishouCreativeLevelOperationRecord);
           if(ok) {
               result.success("修改成功!");
           }
       }

       return result;
   }

   /**
     *   通过id删除
    * @param id
    * @return
    */
   @DeleteMapping(value = "/delete")
   public Result<?> delete(@RequestParam(name="id",required=true) String id) {
       try {
           aiKuaishouCreativeLevelOperationRecordService.removeById(id);
       } catch (Exception e) {
           log.error("删除失败",e.getMessage());
           return Result.error("删除失败!");
       }
       return Result.ok("删除成功!");
   }

   /**
     *  批量删除
    * @param ids
    * @return
    */
   @DeleteMapping(value = "/deleteBatch")
   public Result<AiKuaishouCreativeLevelOperationRecord> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
       Result<AiKuaishouCreativeLevelOperationRecord> result = new Result<>();
       if(ids==null || "".equals(ids.trim())) {
           result.error500("参数不识别！");
       }else {
           this.aiKuaishouCreativeLevelOperationRecordService.removeByIds(Arrays.asList(ids.split(",")));
           result.success("删除成功!");
       }
       return result;
   }

   /**
     * 通过id查询
    * @param id
    * @return
    */
   @GetMapping(value = "/queryById")
   public Result<AiKuaishouCreativeLevelOperationRecord> queryById(@RequestParam(name="id",required=true) String id) {
       Result<AiKuaishouCreativeLevelOperationRecord> result = new Result<>();
       AiKuaishouCreativeLevelOperationRecord aiKuaishouCreativeLevelOperationRecord = aiKuaishouCreativeLevelOperationRecordService.getById(id);
       if(aiKuaishouCreativeLevelOperationRecord==null) {
           result.error500("未找到对应实体");
       }else {
           result.setResult(aiKuaishouCreativeLevelOperationRecord);
           result.setSuccess(true);
       }
       return result;
   }
}
